import { Logger } from '../Logger';
import * as oracledb from 'oracledb';
import { SecretsManager } from '../SecretsManager';
import { Router } from '../Router';
import { RequestContextRegistry } from '../RequestContextRegistry';
import { APIGatewayProxyHandler } from 'aws-lambda';
export declare class HandlerFactory {
    private router;
    private logger;
    private secretsManager;
    private requestContextRegistry;
    private oracleDb;
    private oracleDbConfig;
    constructor(router: Router, logger: Logger, secretsManager: SecretsManager, requestContextRegistry: RequestContextRegistry, oracleDb: typeof oracledb, oracleDbConfig: OracleDbConfig);
    getHandler(): APIGatewayProxyHandler;
}
export interface OracleDbConfig {
    createPool: boolean;
    oracleDbSecretName?: string;
    connectString?: string;
    poolIncrement?: number;
    poolMax?: number;
    poolMin?: number;
}
