"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LocalCache = void 0;
const autobind_decorator_1 = require("autobind-decorator");
const lodash_1 = require("lodash");
const moment_1 = __importDefault(require("moment"));
class LocalCache {
    constructor() {
        this.cache = {};
    }
    get(key) {
        const cacheEntry = this.cache[key];
        if (!cacheEntry)
            return undefined;
        const { expiresEpoch, value } = cacheEntry;
        if (!expiresEpoch)
            return lodash_1.cloneDeep(value);
        if (moment_1.default().unix() > expiresEpoch)
            return undefined;
        return lodash_1.cloneDeep(value);
    }
    set(key, value, options) {
        const expiresEpoch = options?.ttlInSecs ? moment_1.default().add(options?.ttlInSecs, 'second').unix() : null;
        this.cache = {
            ...this.cache,
            [key]: {
                expiresEpoch,
                value: lodash_1.cloneDeep(value),
            },
        };
    }
    clear() {
        this.cache = {};
    }
}
__decorate([
    autobind_decorator_1.boundMethod
], LocalCache.prototype, "get", null);
__decorate([
    autobind_decorator_1.boundMethod
], LocalCache.prototype, "set", null);
__decorate([
    autobind_decorator_1.boundMethod
], LocalCache.prototype, "clear", null);
exports.LocalCache = LocalCache;
