export interface Logger<T = IndexedData> {
    log: (log: T | string | number | null) => void;
    info: (log: T | string | number | null) => void;
    debug: (log: T | string | number | null) => void;
    warn: (log: T | string | number | null) => void;
    error: (log: T | string | number | null) => void;
}
export interface IndexedData extends Record<string, any> {
    type?: string;
    category?: string;
    action?: string;
    label?: string;
    value?: number;
    durationInMillis?: number;
    statusCode?: number;
    code?: string;
    namespace?: string;
    request?: string;
    error?: string;
    errorCode?: string;
    name?: string;
    operator?: string;
    function?: string;
    module?: string;
    path?: string;
    details?: string;
    title?: string;
    field?: string;
    resolver?: string;
    customId?: string;
    customKey?: string;
    customIsoDatetime?: string;
}
